// SDI_TreeViewView.cpp : Implementierung der Klasse CSDI_TreeViewView
//

#include "stdafx.h"
#include "SDI_TreeView.h"

#include "SDI_TreeViewDoc.h"
#include "SDI_TreeViewView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CSDI_TreeViewView

IMPLEMENT_DYNCREATE(CSDI_TreeViewView, CTreeView)

BEGIN_MESSAGE_MAP(CSDI_TreeViewView, CTreeView)
	ON_COMMAND(ID_TREE_BEISPIEL1, &CSDI_TreeViewView::OnTreeBeispiel1)
	ON_COMMAND(ID_TREE_BEISPIEL2, &CSDI_TreeViewView::OnTreeBeispiel2)
	ON_COMMAND(ID_TREE_BEISPIEL3, &CSDI_TreeViewView::OnTreeBeispiel3)
	ON_COMMAND(ID_TREE_BEISPIEL4, &CSDI_TreeViewView::OnTreeBeispiel4)
	ON_COMMAND(ID_TREE_BEISPIEL5, &CSDI_TreeViewView::OnTreeBeispiel5)
	ON_COMMAND(ID_TREE_BEISPIEL6, &CSDI_TreeViewView::OnTreeBeispiel6)
	ON_NOTIFY_REFLECT(TVN_SELCHANGED, OnSelchanged)
END_MESSAGE_MAP()

// CSDI_TreeViewView-Erstellung/Zerstrung

CSDI_TreeViewView::CSDI_TreeViewView()
{
	// TODO: Hier Code zur Konstruktion einfgen

}

CSDI_TreeViewView::~CSDI_TreeViewView()
{
}

BOOL CSDI_TreeViewView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ndern Sie hier die Fensterklasse oder die Darstellung, indem Sie
	//  CREATESTRUCT cs modifizieren.
	cs.style |= TVS_HASLINES | TVS_LINESATROOT | TVS_HASBUTTONS | TVS_SHOWSELALWAYS;

	return CTreeView::PreCreateWindow(cs);
}

void CSDI_TreeViewView::OnInitialUpdate()
{
	CTreeView::OnInitialUpdate();
	m_ilDrives.Create (IDB_DRIVEIMAGES, 16, 1, RGB (255, 0, 255));
	GetTreeCtrl ().SetImageList (&m_ilDrives, TVSIL_NORMAL);
	// LVSIL_NORMAL	LVSIL_SMALL	
}






// CSDI_TreeViewView-Diagnose

#ifdef _DEBUG
void CSDI_TreeViewView::AssertValid() const
{
	CTreeView::AssertValid();
}

void CSDI_TreeViewView::Dump(CDumpContext& dc) const
{
	CTreeView::Dump(dc);
}

CSDI_TreeViewDoc* CSDI_TreeViewView::GetDocument() const // Nicht-Debugversion ist inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CSDI_TreeViewDoc)));
	return (CSDI_TreeViewDoc*)m_pDocument;
}
#endif //_DEBUG


// CSDI_TreeViewView-Meldungshandler

void CSDI_TreeViewView::OnTreeBeispiel1()
{
	GetTreeCtrl().DeleteAllItems();
	m_selChange=false;
	HTREEITEM h1 = GetTreeCtrl().InsertItem("1. Knoten", TVI_ROOT, TVI_LAST);
	HTREEITEM h2 = GetTreeCtrl().InsertItem("2. Knoten");
	HTREEITEM h3 = GetTreeCtrl().InsertItem("3. Knoten", TVI_ROOT, TVI_FIRST);
}// Bsp1

/*
Beispiel zum Eintragen von Knoten mit Symbolen
Jeweils Symbol zum Anzeigen und
Symbol beim Anklicken
*/
void CSDI_TreeViewView::OnTreeBeispiel2()
{
	GetTreeCtrl().DeleteAllItems();
	m_selChange=false;
	HTREEITEM root = GetTreeCtrl().InsertItem("root", 0,0, TVI_ROOT, TVI_LAST);
	HTREEITEM h2 = GetTreeCtrl().InsertItem("2. Knoten",root);
	HTREEITEM h3 = GetTreeCtrl().InsertItem("3. Knoten", 1,2,h2, TVI_FIRST);
	HTREEITEM h4 = GetTreeCtrl().InsertItem("4. Knoten", 2,3,h2, TVI_FIRST);
	HTREEITEM h5 = GetTreeCtrl().InsertItem("5. Knoten, im root",root);
	HTREEITEM h6 = GetTreeCtrl().InsertItem("6. Knoten", 4,5,h5, TVI_FIRST);
	HTREEITEM h7 = GetTreeCtrl().InsertItem("7. Knoten", 4,5,h5, TVI_FIRST);
}// Bsp2

// Verwendung des komplexen Konstruktors
void CSDI_TreeViewView::OnTreeBeispiel3()
{
	GetTreeCtrl().DeleteAllItems();
	m_selChange=false;
	HTREEITEM root = GetTreeCtrl().InsertItem("root", 0,0, TVI_ROOT, TVI_LAST);
	HTREEITEM h1 = GetTreeCtrl().InsertItem(
			 TVIF_IMAGE | TVIF_SELECTEDIMAGE	| TVIF_TEXT,
			"1. Knoten",
			2, 3, 0,0,	NULL,root, NULL);
	HTREEITEM h2 = GetTreeCtrl().InsertItem(
			 TVIF_IMAGE | TVIF_SELECTEDIMAGE	| TVIF_TEXT,
			"2. Knoten",
			2, 3, 0,0,	NULL,root, NULL);
	HTREEITEM h3 = GetTreeCtrl().InsertItem(
			 TVIF_IMAGE | TVIF_SELECTEDIMAGE	| TVIF_TEXT | TVIF_HANDLE,
			"3. Knoten",
			1, 4, TVIS_BOLD, TVIS_STATEIMAGEMASK,	NULL,NULL, h2);
	HTREEITEM h4 = GetTreeCtrl().InsertItem(
			 TVIF_IMAGE | TVIF_SELECTEDIMAGE	| TVIF_TEXT,
			"4. Knoten",
			1, 4, 0,0,	NULL,root,NULL);
	HTREEITEM h5 = GetTreeCtrl().InsertItem(
			 TVIF_IMAGE | TVIF_SELECTEDIMAGE,
			"5. Knoten",
			2, 2, 0,0,	NULL,h4,NULL);
}  // Bsp3

// Verwendung der Struktur
void CSDI_TreeViewView::OnTreeBeispiel4()
{
	GetTreeCtrl().DeleteAllItems();
	m_selChange=false;
	HTREEITEM root = GetTreeCtrl().InsertItem("root", 0,0, TVI_ROOT, TVI_LAST);
	TVINSERTSTRUCT tvInsert;
	tvInsert.hParent = NULL;
	tvInsert.hInsertAfter = NULL;
	tvInsert.item.mask = TVIF_TEXT | TVIF_IMAGE | TVIF_SELECTEDIMAGE;
	tvInsert.item.state=0;
	tvInsert.item.stateMask=TVIS_STATEIMAGEMASK;
	tvInsert.item.lParam=NULL;
	//tvInsert.item.cChildren
	//tvInsert.item.cchTextMax
	//tvInsert.item.hItem
	


/*
HTREEITEM h1 = GetTreeCtrl().InsertItem(
			 TVIF_IMAGE | TVIF_SELECTEDIMAGE	| TVIF_TEXT,
			"1. Knoten",
			2, 3, 0,0,	NULL,root, NULL);
*/
	tvInsert.item.pszText = _T("1. Knoten");
	tvInsert.item.iImage=1;
	tvInsert.item.iSelectedImage=1;
	tvInsert.hParent = root;
	HTREEITEM h1 = GetTreeCtrl().InsertItem(&tvInsert);

	tvInsert.item.pszText = _T("2. Knoten");
	tvInsert.item.iImage=2;
	tvInsert.item.iSelectedImage=2;
	tvInsert.hParent = root;
	HTREEITEM h2 = GetTreeCtrl().InsertItem(&tvInsert);

	tvInsert.item.pszText = _T("3. Knoten");
	tvInsert.item.iImage=2;
	tvInsert.item.iSelectedImage=2;
	tvInsert.hParent = root;
	HTREEITEM h3 = GetTreeCtrl().InsertItem(&tvInsert);

	tvInsert.item.pszText = _T("4. Knoten");
	tvInsert.item.iImage=3;
	tvInsert.item.iSelectedImage=1;
	tvInsert.hParent = h2;
	HTREEITEM h4 = GetTreeCtrl().InsertItem(&tvInsert);
}// Bsp4


void CSDI_TreeViewView::OnTreeBeispiel5()
{
	GetTreeCtrl().DeleteAllItems();
	m_selChange=false;
	TVINSERTSTRUCT tvInsert;
	tvInsert.hParent = NULL;
	tvInsert.hInsertAfter = NULL;
	tvInsert.item.mask = TVIF_TEXT;
	tvInsert.item.pszText = _T("United States");
	/*
	tvInsert.item.iImage=0;
	tvInsert.item.iSelectedImage=0;
	tvInsert.item.state
	tvInsert.item.stateMask
	tvInsert.item.lParam
	*/
	
	tvInsert.item.pszText = _T("HS-HARZ");
	tvInsert.item.mask = TVIF_TEXT;  // Nur Text eintragen, ohne Symbole
	HTREEITEM hHS = GetTreeCtrl().InsertItem(&tvInsert);

	tvInsert.item.pszText = _T("FB AI");
	tvInsert.item.mask = TVIF_TEXT;  // Nur Text eintragen, ohne Symbole
	tvInsert.hParent = hHS;  // mit NULL dann ganz oben eingetragen;
	HTREEITEM hAI = GetTreeCtrl().InsertItem(&tvInsert);

	//HTREEITEM h5 = GetTreeCtrl().InsertItem("Seen", 0,0, TVI_ROOT, TVI_LAST);

	HTREEITEM hVW = GetTreeCtrl().InsertItem(TVIF_TEXT,
	   _T("FB VW"), 0, 0, 0, 0, 0, hHS, NULL);

	// Einfgen von Knoten 2
	// es muss aber nach knoten2 eingefgt werden.

	HTREEITEM hW = GetTreeCtrl().InsertItem(_T("FB W"),
	   0, 0, hHS, hVW);

	HTREEITEM hM = GetTreeCtrl().InsertItem(_T("FB Medizin"),
	   0, 0, hHS, NULL);

	// Nun Studiengnge eintragen, aber sortiert !

	// nun einfach parent EINMAL definieren
	GetTreeCtrl().InsertItem(_T("IB"), hAI, TVI_SORT);
	GetTreeCtrl().InsertItem(_T("PSC"), hAI, TVI_SORT);
	GetTreeCtrl().InsertItem(_T("MB"), hAI, TVI_SORT);
	GetTreeCtrl().InsertItem(_T("Wing"), hAI, TVI_SORT);
	GetTreeCtrl().InsertItem(_T("MI"), hAI, TVI_SORT);

	GetTreeCtrl().InsertItem(_T("ffentliche Verwaltung"), hVW, TVI_SORT);
	GetTreeCtrl().InsertItem(_T("Verwaltungskonomie"), hVW, TVI_SORT);
	GetTreeCtrl().InsertItem(_T("Verwaltungsmanagement / eGovernment"), hVW, TVI_SORT);
	GetTreeCtrl().InsertItem(_T("Europisches Verwaltungsmanagement"), hVW, TVI_SORT);

	GetTreeCtrl().InsertItem(_T("Wirtschaftspsychologie"), hW, TVI_SORT);
	GetTreeCtrl().InsertItem(_T("Betriebswirtschaftslehre"), hW, TVI_SORT);
	GetTreeCtrl().InsertItem(_T("BWL / Dienstleistungsmanagement"), hW, TVI_SORT);
	GetTreeCtrl().InsertItem(_T("Tourismusmanagement"), hW, TVI_SORT);
	GetTreeCtrl().InsertItem(_T("International Business Studies"), hW, TVI_SORT);
	GetTreeCtrl().InsertItem(_T("International Tourism Studies"), hW, TVI_SORT);
	
	// Testbeispiel mit 
	GetTreeCtrl().InsertItem(_T("1 STDG"), hM, TVI_SORT);
	GetTreeCtrl().InsertItem(_T("01 STDG"), hM, TVI_SORT);
	GetTreeCtrl().InsertItem(_T("A STDG"), hM, TVI_SORT);
	GetTreeCtrl().InsertItem(_T(" STDG"), hM, TVI_SORT);
	GetTreeCtrl().InsertItem(_T("Ae STDG"), hM, TVI_SORT);
	GetTreeCtrl().InsertItem(_T(" STDG"), hM, TVI_SORT);
	GetTreeCtrl().InsertItem(_T("ae STDG"), hM, TVI_SORT);
} // bsp5

// zeigt das Klickevent
void CSDI_TreeViewView::OnTreeBeispiel6()
{
	ITEMINFO *p1;
	GetTreeCtrl().DeleteAllItems();

	m_selChange=true;
    try {
		HTREEITEM root = GetTreeCtrl().InsertItem("root", 0,0, TVI_ROOT, TVI_LAST);
		
		p1 = new ITEMINFO;
		p1->sName="Datei knoten1.dat";
		p1->id=1234;
		HTREEITEM h1 = GetTreeCtrl().InsertItem(
				 TVIF_IMAGE | TVIF_SELECTEDIMAGE | TVIF_TEXT | TVIF_PARAM,
				"1. Knoten",
				2, 3, 0,0,	(LPARAM) p1,root, NULL);
		
        p1 = new ITEMINFO;
		p1->sName="Datei knoten2.dat";
		p1->id=-555;
		HTREEITEM h2 = GetTreeCtrl().InsertItem(
				 TVIF_IMAGE | TVIF_SELECTEDIMAGE | TVIF_TEXT | TVIF_PARAM,
				"2. Knoten",
				1, 2, 0,0,	(LPARAM) p1,root, NULL);

        p1 = new ITEMINFO;
		p1->sName="Datei knoten2.dat";
		p1->id=5678;
		HTREEITEM h3 = GetTreeCtrl().InsertItem(
				 TVIF_IMAGE | TVIF_SELECTEDIMAGE | TVIF_TEXT | TVIF_PARAM,
				"3. Knoten",
				1, 4, 0,0,	(LPARAM)  p1,h1, NULL);
    }
    catch (CMemoryException* e) {
        e->Delete ();
    }
}

/*
CString CSDI_TreeViewView::GetPathFromItem(HTREEITEM hItem)
{
	CString strResult = GetTreeCtrl ().GetItemText (hItem);

	HTREEITEM hParent;
	while ((hParent = GetTreeCtrl ().GetParentItem (hItem)) != NULL) {
		CString string = GetTreeCtrl ().GetItemText (hParent);
		if (string.Right (1) != _T ("\\"))
			string += _T ("\\");
			strResult = string + strResult;
			hItem = hParent;
	}
	return strResult;
}
*/
void CSDI_TreeViewView::OnSelchanged(NMHDR* pNMHDR, LRESULT* pResult) 
{
	if (m_selChange) {
		ITEMINFO *p1;
		CString sStr;
		NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
		p1 = (ITEMINFO *)pNMTreeView->itemNew.lParam;
		sStr.Format("Name: %s\nid: %d",p1->sName,p1->id);
		AfxMessageBox( sStr );
		// CString strPath = GetPathFromItem (pNMTreeView->itemNew.hItem);
		//AfxMessageBox( strPath );
		// GetDocument ()->UpdateAllViews (this, 0xA1, (CObject*) (LPCTSTR) strPath);
	}
	*pResult = 0;
}
